import { DeepClient } from '@deep-foundation/deeplinks/imports/client';
import { PushNotification } from './push-notification';
/**
 * Gets push notification from deep
 *
 * @throws {Error} If title is not found
 * @throws {Error} If body is not found
 */
export declare function getPushNotification({ deep, pushNotificationLinkId, }: GetPushNotificationParam): Promise<PushNotification>;
export interface GetPushNotificationParam {
    /**
     * Deep Client
     */
    deep: DeepClient;
    /**
     * Link id of push notification
     */
    pushNotificationLinkId: number;
}
