"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.insertDeviceRegistrationToken = void 0;
const package_name_1 = require("./package-name");
const contains_1 = require("./contains");
/**
 * Inserts device registration token
 *
 * @remarks
 * Device registration token will be contained in device
 */
function insertDeviceRegistrationToken({ deep, deviceRegistrationToken, deviceLinkId }) {
    return __awaiter(this, void 0, void 0, function* () {
        const deviceRegistrationTokenTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.DeviceRegistrationToken]);
        const containTypeLinkId = yield deep.id('@deep-foundation/core', 'Contain');
        const { data: [{ id: deviceRegistrationTokenLinkId }], } = yield deep.insert({
            type_id: deviceRegistrationTokenTypeLinkId,
            string: {
                data: {
                    value: deviceRegistrationToken,
                },
            },
            in: {
                data: [{
                        type_id: containTypeLinkId,
                        from_id: deviceLinkId,
                    },
                ],
            },
        });
        return { deviceRegistrationTokenLinkId };
    });
}
exports.insertDeviceRegistrationToken = insertDeviceRegistrationToken;
;
