"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.insertPushNotification = void 0;
const package_name_1 = require("./package-name");
const contains_1 = require("./contains");
/**
 * Inserts push notification
 */
function insertPushNotification(param) {
    return __awaiter(this, void 0, void 0, function* () {
        const { deep, pushNotification, containerLinkId = deep.linkId } = param;
        const pushNotificationTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.PushNotification]);
        const titleTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.PushNotificationTitle]);
        const bodyTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.PushNotificationBody]);
        const imageUrlTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.PushNotificationImageUrl]);
        const syncTextFileTypeLinkId = yield deep.id('@deep-foundation/core', 'SyncTextFile');
        const containTypeLinkId = yield deep.id('@deep-foundation/core', 'Contain');
        yield deep.insert({
            type_id: pushNotificationTypeLinkId,
            in: {
                data: [
                    {
                        type_id: containTypeLinkId,
                        from_id: containerLinkId,
                    },
                ],
            },
            out: {
                data: [
                    {
                        type_id: titleTypeLinkId,
                        to: {
                            data: {
                                type_id: syncTextFileTypeLinkId,
                                in: {
                                    data: [
                                        {
                                            type_id: containTypeLinkId,
                                            from_id: containerLinkId,
                                        },
                                    ],
                                },
                                string: {
                                    data: {
                                        value: pushNotification.title,
                                    },
                                },
                            },
                        },
                        in: {
                            data: [
                                {
                                    type_id: containTypeLinkId,
                                    from_id: containerLinkId,
                                },
                            ],
                        },
                    },
                    {
                        type_id: bodyTypeLinkId,
                        to: {
                            data: {
                                type_id: syncTextFileTypeLinkId,
                                in: {
                                    data: [
                                        {
                                            type_id: containTypeLinkId,
                                            from_id: containerLinkId,
                                        },
                                    ],
                                },
                                string: {
                                    data: {
                                        value: pushNotification.body,
                                    },
                                },
                            },
                        },
                        in: {
                            data: [
                                {
                                    type_id: containTypeLinkId,
                                    from_id: containerLinkId,
                                },
                            ],
                        },
                    },
                    ...(pushNotification.image ? [{
                            type_id: imageUrlTypeLinkId,
                            to: {
                                data: {
                                    type_id: syncTextFileTypeLinkId,
                                    in: {
                                        data: [
                                            {
                                                type_id: containTypeLinkId,
                                                from_id: containerLinkId,
                                            },
                                        ],
                                    },
                                    string: {
                                        data: {
                                            value: pushNotification.body,
                                        },
                                    },
                                },
                            },
                            in: {
                                data: [
                                    {
                                        type_id: containTypeLinkId,
                                        from_id: containerLinkId,
                                    },
                                ],
                            },
                        }] : [])
                ],
            },
        });
    });
}
exports.insertPushNotification = insertPushNotification;
