import { DeepClient } from '@deep-foundation/deeplinks/imports/client';
/**
 * Inserts service account
 */
export declare function insertServiceAccount(param: InsertServiceAccountParam): Promise<void>;
export interface InsertServiceAccountParam {
    /**
     * Deep Client
     */
    deep: DeepClient;
    /**
     * Service Account
     *
     * @remarks
     * You can find it in firebase console under project settings
     */
    serviceAccount: object;
    /**
     * Is this service account should be made active
     *
     * @remarks
     * You can have multiple service account and only one can be active. It is made active when UsesServiceAccount is pointing to it
     */
    makeActive?: boolean;
}
