"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.insertServiceAccount = void 0;
const package_name_1 = require("./package-name");
const contains_1 = require("./contains");
/**
 * Inserts service account
 */
function insertServiceAccount(param) {
    return __awaiter(this, void 0, void 0, function* () {
        const { deep, serviceAccount, makeActive = false, } = param;
        const containTypeLinkId = yield deep.id('@deep-foundation/core', 'Contain');
        const serviceAccountTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.ServiceAccount]);
        const usesServiceAccountTypeLinkId = yield deep.id(package_name_1.FIREBASE_PUSH_NOTIFICATION_PACKAGE_NAME, contains_1.FirebasePushNotificationContains[contains_1.FirebasePushNotificationContains.UsesServiceAccount]);
        if (makeActive) {
            yield deep.delete({
                up: {
                    tree_id: { _eq: yield deep.id('@deep-foundation/core', 'containTree') },
                    parent: {
                        type_id: { _id: ['@deep-foundation/core', 'Contain'] },
                        to: { type_id: usesServiceAccountTypeLinkId },
                        from_id: deep.linkId,
                    },
                },
            });
        }
        yield deep.insert({
            type_id: serviceAccountTypeLinkId,
            object: {
                data: {
                    value: serviceAccount,
                },
            },
            in: {
                data: [
                    {
                        type_id: containTypeLinkId,
                        from_id: deep.linkId,
                    },
                    ...(makeActive
                        ? [
                            {
                                type_id: usesServiceAccountTypeLinkId,
                                from_id: deep.linkId,
                                in: {
                                    data: [
                                        {
                                            type_id: containTypeLinkId,
                                            from_id: deep.linkId,
                                        },
                                    ],
                                },
                            },
                        ]
                        : []),
                ],
            },
        });
    });
}
exports.insertServiceAccount = insertServiceAccount;
