"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestPermissions = void 0;
const device_1 = require("@capacitor/device");
const push_notifications_1 = require("@capacitor/push-notifications");
/**
 * Requiests notification permissions
 * @returns
 */
function requestPermissions() {
    return __awaiter(this, void 0, void 0, function* () {
        const { platform } = yield device_1.Device.getInfo();
        let isPermissionsGranted;
        if (platform === 'web') {
            const permissionsStatus = yield Notification.requestPermission();
            isPermissionsGranted = permissionsStatus === 'granted';
        }
        else {
            const permissionsStatus = yield push_notifications_1.PushNotifications.requestPermissions();
            isPermissionsGranted = permissionsStatus.receive === 'granted';
        }
        return isPermissionsGranted;
    });
}
exports.requestPermissions = requestPermissions;
